math.randomseed(os.time())

parse("sv_gamemode 2")
parse("mp_autoteambalance 0")
parse("mp_deathdrop 4")
parse("mp_hud 0")

gun = 32
min_strf_len = 10
max_strf_len = 25

ai_tab = {}
for i = 1,32 do
	ai_tab[i] = {["weapon"] = 50, ["strf"] = {}, ["strf_ind"] = 1}
end

addhook("spawn", "fl_aim_spawn")
function fl_aim_spawn(id)
	parse("setarmor "..id.." 100")
	parse("strip "..id)
	parse("equip "..id.." "..gun)
	if id == 1 then
		parse("bot_remove_all")
		local str = (player(1, "team") == 1) and "ct" or "t"
		for i=1,32 do
			if not player(i, "exists") then
				activeid = i
				break
			end
		end
		parse("bot_add_"..str)
		parse("bot_add_"..str)
		timer(20, "delayed_onkill", "1")
		timer(2000, "delayed_onkill", "1")
	end
end

addhook("reload", "fl_aim_onrl")
function fl_aim_onrl(id, mode)
	if mode == 1 then
		parse("equip "..id.." "..gun)
		parse("setweapon "..id.." "..gun)
	end
end

shots=0
addhook("attack", "fl_aim_onattack")
function fl_aim_onattack(id)
	if id ~=1 then return end
	shots = shots + 1
end

addhook("hit", "fl_aim_onhit")
function fl_aim_onhit(vic, att)
	if vic ~= activeid then return 1 end
end

kills = 0

cur_time = 0
start_time = 0
addhook("ms100", "lol")
function lol() cur_time = cur_time + 0.1 end

addhook("kill", "fl_aim_onkill")
function fl_aim_onkill(id, vic)
	local x = 0.5 * (player(vic, "x") - player(id, "x")) + 320
	local y = 0.5 * (player(vic, "y") - player(id, "y")) + 240
	local col = "000255000"
	if (shots+1) > 15 then
		col = "255000000"
	elseif (shots+1) > 10 then
		col = "188188000"
	end
	parse("hudtxt2 "..id.." 0 \"©"..col..(shots+1).."\" "..x.." "..y.." 1")
	kills = kills + 1
	if kills == 100 then
		msg("GG. time to kill 100 bots: "..(cur_time - start_time))
		parse("bot_remove_all")
		return
	end
	timer(500, "delayed_onkill", tostring(id))
end

function delayed_onkill(id)
	if kills == 0 then
		start_time = cur_time
	end
	shots = 0
	parse("equip "..id.." "..gun)
	parse("spawnplayer "..activeid.." 16 16")
end

function ai_onspawn(id)
	ai_selectweapon(id, 50)
	ai_tab[id].weapon = 50	
	ai_tab[id].strf = {} --garbage collect plz work

	for i = 1,32 do
		if i~=id and player(i, "bot") then
			activeid = i
			break
		end
	end

	local x = math.random() * 640 - 320
	local y = math.random() * 480 - 240
	parse("setpos "..activeid.." "..(player(1, "x") + x).." "..(player(1, "y") + y))
end

function gen_strafe(min, max, len)
	local t = {}
	local i = 1
	local s = math.random(0,1)
	for j = 1, len do
		s = 1 - s
		for k = 1, math.random(min, max) do
			t[i] = s
			i = i + 1
		end
	end
	return t
end

function get_strafe(id)
	local s = ai_tab[id].strf[ai_tab[id].strf_ind]
	if not s then
		ai_tab[id].strf_ind = 1
		ai_tab[id].strf = gen_strafe(min_strf_len, max_strf_len, 10)
		s = ai_tab[id].strf[1]
	end
	ai_tab[id].strf_ind = ai_tab[id].strf_ind + 1
	return s
end

function ai_update_living(id)
	if id ~= activeid then return end
	local px, py = player(1, "x"), player(1, "y")
	local aix, aiy = player(id, "x"), player(id, "y")
	local angle = math.atan2(px-aix, aiy-py)
	ai_rotate(id, math.deg(angle))
	if math.abs(px - aix) > (320-16) or math.abs(py-aiy) > (240-16) then
		if ai_tab[id].weapon ~= 50 then
			ai_selectweapon(id, 50)
			ai_tab[id].weapon = 50
		end
		ai_move(id, math.deg(absmov(angle)))
	else
		if ai_tab[id].weapon ~= gun then
			ai_selectweapon(id, gun)
			ai_tab[id].weapon = gun
		end
		ai_move(id, get_strafe(id) * 180 + math.deg(math.pi/2 + absmov(angle)))
		ai_iattack(id)
	end
end

function absmov(angle)
	return (math.pi/4) * math.floor(angle/(math.pi/4) + 0.5)
end

function ai_update_dead(id)
end

function ai_hear_radio()
end

function ai_hear_chat()
end
